#Copyright 2010 Daniel Monedero Tortola faltantornillos at gmail.com

#This file is part of Bright Player 0.4.

#    Bright Player 0.4 is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.

#    Bright Player 0.4 is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.

#    You should have received a copy of the GNU General Public License
#    along with Foobar.  If not, see <http://www.gnu.org/licenses/>.

import os
import commands
import sys
import atexit
import ConfigParser
from signal import signal, SIGTERM

#Settings:
BrightConfig = ConfigParser.ConfigParser()
BrightConfig.read(os.path.join(os.environ['HOME'], '.brightPlayer.conf'))

def updateVariable(value, name):
	global BrightConfig
	BrightConfig.set('DEFAULT', name, value)

def setVariable(name, default):
	global BrightConfig
	if BrightConfig.has_option('DEFAULT', name):
		return str(BrightConfig.get('DEFAULT', name))
	else:
		BrightConfig.set('DEFAULT', name, default)
		return default

defaultVolume=setVariable('defaultvolume', '118')
musicPathOn=setVariable('musicpathon', '/media/mmcblk0p2/home/root/MusicOn/*')
moodMode=setVariable('moodmode', 'False')
if(moodMode == 'True'):
	musicPathOff=setVariable('musicpathoff', '/media/mmcblk0p2/home/root/MusicOff/*')

playing = 0
muted=0
unmutedValue=0.0
one=-1
two=-1
three=-1
four=-1

def clean():
	global playing
	unlock()
	os.system('xset s on');
	if playing == 1:
		playing=0
		os.system('killall mplayer & amixer cset iface=MIXER,name=\'Amp Spk Switch\' off > /dev/null & kill `ps -e -o pid,command | grep [b]rightDetector.py | awk {\'print $1\'}` &')

def exit(widget):
	global BrightConfig
	clean()
	#save config file
	with open(os.path.join(os.environ['HOME'], '.brightPlayer.conf'), 'wb') as configfile:
		BrightConfig.write(configfile)
	sys.exit(0)

def volume(volume):
	os.system ('amixer sset \'Headphone\' '+volume+' > /dev/null &')
	updateVariable(volume, 'defaultvolume')

def mute():
	global unmutedValue
	global muted
	if muted==0 :
		os.system ('amixer sset \'Headphone\' 0 > /dev/null &')
		muted=1
	else :
		os.system ('amixer sset \'Headphone\' '+str(unmutedValue)+' > /dev/null &')
		muted=0

def lock():
	global playing
	os.system('echo 1 > /sys/class/backlight/gta02-bl/bl_power')
	if playing == 1:
		#high priority
		os.system('renice -15 -p $(pidof mplayer)')

def unlock():
	os.system('echo 0 > /sys/class/backlight/gta02-bl/bl_power')

def play(target, parameter):
	global playing
	global musicPathOn
	global musicPathOff
	global defaultVolume
	os.system('xset s off');
	if playing == 0:
		lock()
		playing = 1
		#set alsa
		os.system ('amixer sset \'Headphone\' '+defaultVolume+' > /dev/null &')
		if (parameter == 'handOn') or (parameter == 'handOff'):
			os.system('amixer cset iface=MIXER,name=\'Amp Spk Switch\' on > /dev/null &')
		else:
			os.system('amixer cset iface=MIXER,name=\'Amp Spk Switch\' off > /dev/null &')
		#play right path
		if (parameter == 'handOn') or (parameter == 'headOn'):
			os.system('nice -n -15 mplayer -really-quiet -noconsolecontrols -nojoystick -nolirc -nomouseinput -shuffle '+musicPathOn+' > /dev/null &')
		else:
			os.system('nice -n -15 mplayer -really-quiet -noconsolecontrols -nojoystick -nolirc -nomouseinput -shuffle '+musicPathOff+' > /dev/null &')
		#exit on call
		os.system('python /usr/bin/brightDetector.py > /dev/null &')

def first(target):
	global one
	global two
	global three
	global four
	one=1
	two=-1
	three=-1
	four=-1

def second(target):
	global one
	global two
	global three
	global four
	if one==1:
		two=1
	else:
		one=-1
		two=-1
		three=-1
		four=-1

def third(target):
	global one
	global two
	global three
	global four
	if two==1:
		three=1
	else:
		one=-1
		two=-1
		three=-1
		four=-1

def fourth():
	global one
	global two
	global three
	global four
	four*=-1
	if one==1 and two==1 and three==1 and four==1:
		#normal priority
		os.system('renice +0 -p $(pidof mplayer)')
	else:
		one=-1
		two=-1
		three=-1
		four=-1

def main():
	atexit.register(clean)
	signal(SIGTERM, lambda signum, stack_frame: exit(0))

if __name__ == '__main__':
	main()
